<template>
    <modal
        name="store-bank"
        height="auto"
        :shiftY="0.2"
        @before-open="beforeOpen"
        :clickToClose="false"
        :scrollable="true"
    >
        <div class="modal-header">
            <h5 class="modal-title">Bank Account</h5>

            <div class="close" @click="$modal.hide('store-bank')">
                <span aria-hidden="true">&times;</span>
            </div>
        </div>

        <div class="modal-body">
            <div class="form-group">
                <label>Name</label>
                <input type="text" v-model="bank.name" class="form-control" />
            </div>

            <div class="form-group mt-4">
                <label>Account</label>
                <input
                    type="text"
                    v-model="bank.account"
                    class="form-control"
                />
            </div>

            <div class="form-group mt-4">
                <label>Unique Tax Number</label>
                <input type="text" v-model="bank.edb" class="form-control" />
            </div>

            <div class="form-group mt-4">
                <label><i>(optional)</i> Address</label>
                <input type="text" v-model="bank.street" class="form-control" />
            </div>

            <div class="form-group mt-4">
                <label><i>(optional)</i> City</label>
                <input type="text" v-model="bank.city" class="form-control" />
            </div>

            <div class="form-group mt-4">
                <label><i>(optional)</i> Phone</label>
                <input type="text" v-model="bank.phone" class="form-control" />
            </div>
        </div>

        <div class="modal-footer">
            <button
                v-if="view == 'create'"
                type="button"
                class="btn btn-success"
                :disabled="!bank.name || !bank.account || !bank.edb"
                @click="create()"
            >
                <i class="fas fa-save pr-2"></i> Create
            </button>

            <button
                v-if="view == 'edit'"
                type="button"
                class="btn btn-success"
                :disabled="!bank.name || !bank.account || !bank.edb"
                @click="update()"
            >
                <i class="fas fa-save pr-2"></i> Update
            </button>

            <button
                v-if="view == 'edit'"
                type="button"
                class="btn btn-danger"
                @click="remove()"
            >
                <i class="fas fa-trash pr-2"></i> Delete
            </button>
        </div>
    </modal>
</template>

<script>
export default {
    props: ["banks"],

    data() {
        return {
            bank: {
                name: null,

                account: null,

                edb: null,

                street: "",

                city: "",

                phone: ""
            },

            view: "create"
        };
    },

    methods: {
        beforeOpen(event) {
            event.params.bank
                ? (this.bank = JSON.parse(JSON.stringify(event.params.bank)))
                : [];

            event.params.view ? (this.view = event.params.view) : [];
        },

        create() {
            axios.post("/api/banks/store", this.bank).then(response => {
                // Close modal
                this.$modal.hide("store-bank");

                // Add bank in list
                this.banks.unshift(response.data);

                this.$emit("bank-create", { bank: response.data });

                // Show notification
                this.$toasted.show(
                    "<i class='fas fa-check mr-2'></i> Bank Account Succesfully Created"
                );
            });
        },

        update() {
            axios
                .put("/api/banks/" + this.bank.id, this.bank)
                .then(response => {
                    const index = this.banks.findIndex(item => {
                        return response.data.id === item.id;
                    });

                    this.banks.splice(index, 1, response.data);

                    // Close modal
                    this.$modal.hide("store-bank");

                    // Show notification
                    this.$toasted.show(
                        "<i class='fas fa-check mr-2'></i> Bank Account Succesfully Updated"
                    );
                });
        },

        remove() {
            Vue.toasted.clear();

            this.$toasted.show(
                "<i class='fas fa-trash-alt mr-2'> </i> Delete Bank Account ?",
                {
                    type: "error",

                    duration: null,

                    action: [
                        {
                            text: "Yes",

                            onClick: (e, toastObject) => {
                                toastObject.goAway(0);

                                axios
                                    .post("/api/banks/delete/" + this.bank.id)
                                    .then(response => {
                                        this.banks.splice(this.bank, 1);

                                        // Close modal
                                        this.$modal.hide("store-bank");

                                        this.$toasted.show(
                                            "<i class='fas fa-check mr-2'></i> Bank Account Successfully Deleted !"
                                        );
                                    });
                            }
                        },
                        {
                            text: "Cancel",

                            onClick: (e, toastObject) => {
                                toastObject.goAway(0);
                            }
                        }
                    ]
                }
            );
        }
    }
};
</script>
